Index: lib/TWiki/UI/Edit.pm
===================================================================
--- lib/TWiki/UI/Edit.pm	(revision 1767)
+++ lib/TWiki/UI/Edit.pm	(working copy)
@@ -32,6 +32,7 @@
 use TWiki::Prefs;
 use TWiki::Store;
 use TWiki::UI;
+use TWiki::Templates;
 
 =pod
 
@@ -60,7 +61,7 @@
   my $templateTopic = $query->param( "templatetopic" ) || "";
   # apptype is undocumented legacy
   my $cgiAppType = $query->param( 'contenttype' ) || $query->param( 'apptype' ) || "text/html";
-  my $skin = $query->param( "skin" );
+  my $skin = TWiki::getSkin();
   my $theParent = $query->param( 'topicparent' ) || "";
   my $ptext = $query->param( 'text' );
 
@@ -69,7 +70,7 @@
   return unless TWiki::UI::webExists( $webName, $topic );
 
   return if TWiki::UI::isMirror( $webName, $topic );
-
+print STDERR "One\n";
   my $tmpl = "";
   my $text = "";
   my $meta = "";
@@ -86,7 +87,7 @@
   # prevent non-Wiki names?
   if( ( $onlyWikiName )
       && ( ! $topicExists )
-      && ( ! ( &TWiki::isWikiName( $topic ) || &TWiki::isAbbrev( $topic ) ) ) ) {
+      && ( ! TWiki::isValidTopicName( $topic ) ) ) {
     # do not allow non-wikinames, redirect to view topic
     TWiki::UI::redirect( TWiki::getViewUrl( $webName, $topic ) );
     return;
@@ -97,7 +98,7 @@
     ( $meta, $text ) = &TWiki::Store::readTopic( $webName, $topic );
   }
 
-  my $wikiUserName = &TWiki::userToWikiName( $userName );
+  my $wikiUserName = &TWiki::User::userToWikiName( $userName );
   return unless TWiki::UI::isAccessPermitted( $webName, $topic,
                                             "change", $wikiUserName );
 
@@ -108,7 +109,7 @@
   my( $lockUser, $lockTime ) = &TWiki::Store::topicIsLockedBy( $webName, $topic );
   if( ( ! $breakLock ) && ( $lockUser ) ) {
     # warn user that other person is editing this topic
-    $lockUser = &TWiki::userToWikiName( $lockUser );
+    $lockUser = &TWiki::User::userToWikiName( $lockUser );
     use integer;
     $lockTime = ( $lockTime / 60 ) + 1; # convert to minutes
     my $editLock = $TWiki::editLockTime / 60;
@@ -116,13 +117,13 @@
                      $lockUser, $editLock, $lockTime );
     return;
   }
-  &TWiki::Store::lockTopic( $topic );
+  TWiki::Store::lockTopic( $webName, $topic );
 
   my $templateWeb = $webName;
 
+print STDERR "Two\n";
   # Get edit template, standard or a different skin
-  $skin = TWiki::Prefs::getPreferencesValue( "SKIN" ) unless ( $skin );
-  $tmpl = &TWiki::Store::readTemplate( "edit", $skin );
+  $tmpl = &TWiki::Templates::readTemplate( "edit", $skin );
   unless( $topicExists ) {
     if( $templateTopic ) {
       if( $templateTopic =~ /^(.+)\.(.+)$/ ) {
@@ -131,10 +132,10 @@
         $templateTopic = $2;
       }
 
-      ( $meta, $text ) = &TWiki::Store::readTopic( $templateWeb, $templateTopic );
+      ( $meta, $text ) = TWiki::Templates::readTopic( $templateWeb, $templateTopic );
     }
     unless( $text ) {
-      ( $meta, $text ) = &TWiki::Store::readTemplateTopic( "WebTopicEditTemplate" );
+      ( $meta, $text ) = TWiki::UI::readTemplateTopic( "WebTopicEditTemplate" );
     }
     $extra = "(not exist)";
 
@@ -179,6 +180,7 @@
     }
   }
 
+print STDERR "Three\n";
   if( $saveCmd eq "repRev" ) {
     $text = TWiki::Store::readTopicRaw( $webName, $topic );
   }
@@ -194,7 +196,7 @@
 
   if( $TWiki::doLogTopicEdit ) {
     # write log entry
-    &TWiki::Store::writeLog( "edit", "$webName.$topic", $extra );
+    TWiki::writeLog( "edit", "$webName.$topic", $extra );
   }
 
   if( $saveCmd ) {
@@ -202,11 +204,7 @@
   }
   $tmpl =~ s/%CMD%/$saveCmd/go;
   $tmpl = &TWiki::handleCommonTags( $tmpl, $topic );
-  if( $saveCmd ne "repRev" ) {
-    $tmpl = &TWiki::handleMetaTags( $webName, $topic, $tmpl, $meta );
-  } else {
-    $tmpl =~ s/%META{[^}]*}%//go;
-  }
+  $tmpl = &TWiki::Render::renderMetaTags( $webName, $topic, $tmpl, $meta, $saveCmd eq "repRev" );
   $tmpl = &TWiki::Render::getRenderedVersion( $tmpl );
 
   # Don't want to render form fields, so this after getRenderedVersion
@@ -233,6 +231,7 @@
     $tmpl =~ s/%FORMFIELDS%//go;
   }
 
+print STDERR "Four\n";
   $tmpl =~ s/%FORMTEMPLATE%//go; # Clear if not being used
   $tmpl =~ s/%TEXT%/$text/go;
   $tmpl =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
Index: lib/TWiki/UI/Changes.pm
===================================================================
--- lib/TWiki/UI/Changes.pm	(revision 1767)
+++ lib/TWiki/UI/Changes.pm	(working copy)
@@ -34,10 +34,9 @@
 
   return unless TWiki::UI::webExists( $webName, $topic );
 
-  my $skin = $query->param( "skin" );
-  $skin = TWiki::Prefs::getPreferencesValue( "SKIN" ) unless ( $skin );
+  my $skin = TWiki::getSkin();
 
-  my $text = TWiki::Store::readTemplate( "changes", $skin );
+  my $text = TWiki::Templates::readTemplate( "changes", $skin );
   my $changes= TWiki::Store::readFile( "$TWiki::dataDir/$webName/.changes" );
 
   my @bar = ();
@@ -54,17 +53,18 @@
   my $before = "";
   my $after = "";
   ( $before, $text, $after) = split( /%REPEAT%/, $text );
-  &TWiki::writeHeader( $query );
+
   $before =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;  # remove <nop> and <noautolink> tags
-  print $before;
 
+  my $page = $before;
+
   foreach( reverse split( /\n/, $changes ) ) {
     @bar = split( /\t/ );
     if( ( ! %exclude ) || ( ! $exclude{ $bar[0] } ) ) {
       next unless TWiki::Store::topicExists( $webName, $bar[0] );
       $foo = $text;
       $foo =~ s/%TOPICNAME%/$bar[0]/go;
-      my $wikiuser = &TWiki::userToWikiName( $bar[1] );
+      my $wikiuser = &TWiki::User::userToWikiName( $bar[1] );
       $foo =~ s/%AUTHOR%/$wikiuser/go;
       $foo =~ s/%LOCKED%//go;
       $time = &TWiki::formatTime( $bar[2] );
@@ -78,24 +78,27 @@
       }
       $foo =~ s/%TIME%/$time/go;
       $foo =~ s/%REVISION%/$frev/go;
-      $foo = &TWiki::Render::getRenderedVersion( $foo );
+      $foo = TWiki::Render::getRenderedVersion( $foo );
       
-      $summary = &TWiki::Store::readFileHead( "$TWiki::dataDir\/$webName\/$bar[0].txt", 16 );
-      $summary = &TWiki::makeTopicSummary( $summary, $bar[0], $webName );
+      $summary = TWiki::Store::readFileHead( "$TWiki::dataDir\/$webName\/$bar[0].txt", 16 );
+      $summary = TWiki::Render::makeTopicSummary( $summary, $bar[0], $webName );
       $foo =~ s/%TEXTHEAD%/$summary/go;
       $foo =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
-      print $foo;
+      $page .= $foo;
       $exclude{ $bar[0] } = "1";
     }
   }
   
   if( $TWiki::doLogTopicChanges ) {
     # write log entry
-    &TWiki::Store::writeLog( "changes", $webName, "" );
+    TWiki::writeLog( "changes", $webName, "" );
   }
   
   $after =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
-  print $after;
+  $page .= $after;
+
+  TWiki::writeHeader( $query, length( $page ));
+  print $page;
 }
 
 1;
Index: lib/TWiki/UI/Manage.pm
===================================================================
--- lib/TWiki/UI/Manage.pm	(revision 1767)
+++ lib/TWiki/UI/Manage.pm	(working copy)
@@ -28,6 +28,7 @@
 use TWiki;
 use TWiki::UI;
 use TWiki::User;
+use TWiki::Templates;
 
 =pod
 
@@ -83,7 +84,7 @@
   #    my @refs = &TWiki::Store::findReferringPages( $oldWeb, $oldTopic );
   #    my $problems;
   #    ( $lockFailure, $problems ) = 
-  #       &TWiki::Store::updateReferingPages( $oldWeb, $oldTopic, $wikiUserName, $newWeb, $newTopic, @refs );
+  #       &TWiki::Store::updateReferringPages( $oldWeb, $oldTopic, $wikiUserName, $newWeb, $newTopic, @refs );
 
   TWiki::User::RemoveUser($wikiName);
 
@@ -188,7 +189,7 @@
   my $oopsTmpl = "mngcreateweb";
 
   # check permission, user authorized to create webs?
-  my $wikiUserName = TWiki::userToWikiName( $userName );
+  my $wikiUserName = TWiki::User::userToWikiName( $userName );
   return unless TWiki::UI::isAccessPermitted( $webName, $topicName,
                                               "manage", $wikiUserName );
 
@@ -196,7 +197,7 @@
     # valid template web name, untaint
     $newWeb =~ /(.*)/;
     $newWeb = $1;
-  } elsif( TWiki::isWebName( $newWeb ) ) {
+  } elsif( TWiki::isValidWebName( $newWeb ) ) {
     # valid web name, untaint
     $newWeb =~ /(.*)/;
     $newWeb = $1;
@@ -391,7 +392,7 @@
   my $doAllowNonWikiWord = $query->param( 'nonwikiword' ) || "";
   my $justChangeRefs = $query->param( 'changeRefs' ) || "";
 
-  my $skin = $query->param( "skin" ) || TWiki::Prefs::getPreferencesValue( "SKIN" );
+  my $skin = TWiki::getSkin();
 
   $newTopic =~ s/\s//go;
   $newTopic =~ s/$TWiki::securityFilter//go;
@@ -400,17 +401,13 @@
     $theAttachment = "";
   }
 
-  my $wikiUserName = &TWiki::userToWikiName( $userName );
+  my $wikiUserName = &TWiki::User::userToWikiName( $userName );
 
   # justChangeRefs will be true when some topics that had links to $oldTopic
   # still need updating, previous update being prevented by a lock.
 
-  my $fileName = &TWiki::Store::getFileName( $oldWeb, $oldTopic );
-  my $newName;
-  $newName = &TWiki::Store::getFileName( $newWeb, $newTopic ) if( $newWeb );
-
   if( ! $justChangeRefs ) {
-    if( _checkExist( $oldWeb, $oldTopic, $newWeb, $newTopic, $theAttachment, $fileName, $newName ) ) {
+    if( _checkExist( $oldWeb, $oldTopic, $newWeb, $newTopic, $theAttachment )) {
       return;
     }
 
@@ -435,14 +432,46 @@
   if( ! $justChangeRefs ) {
     if( $theAttachment ) {
       my $moveError = 
-        &TWiki::Store::moveAttachment( $oldWeb, $oldTopic, $newWeb, $newTopic, $theAttachment );
+        TWiki::Store::moveAttachment( $oldWeb, $oldTopic,
+                                      $newWeb, $newTopic,
+                                      $theAttachment );
+
+      my( $meta, $text ) = readTopic( $oldWeb, $oldTopic );
+      my %fileAttachment =
+        $meta->findOne( "FILEATTACHMENT", $theAttachment );
+      $meta->remove( "FILEATTACHMENT", $theAttachment );
+      $moveError .=
+        TWiki::Store::noHandlersSave( $oldWeb, $oldTopic, $text, $meta,
+                                          "", "", "", "doUnlock",
+                                          "dont notify", "" ); 
+      # Remove lock
+      lockTopic( $oldWeb, $oldTopic, 1 );
+
+      # Add file attachment to new topic
+      ( $meta, $text ) = readTopic( $newWeb, $newTopic );
+      $fileAttachment{"movefrom"} = "$oldWeb.$oldTopic";
+      $fileAttachment{"moveby"}   = $TWiki::userName;
+      $fileAttachment{"movedto"}  = "$newWeb.$newTopic";
+      $fileAttachment{"movedwhen"} = time();
+      $meta->put( "FILEATTACHMENT", %fileAttachment );
+
+      $moveError .=
+        TWiki::Store::noHandlersSave( $newWeb, $newTopic, $text, $meta,
+                                          "", "", "", "doUnlock",
+                                          "dont notify", "" ); 
+      # Remove lock file.
+      lockTopic( $newWeb, $newTopic, 1 );
+
+      TWiki::writeLog( "move", "$oldWeb.$oldTopic",
+                "Attachment $theAttachment moved to $newWeb.$newTopic" );
+
       if( $moveError ) {
         TWiki::UI::oops( $newWeb, $newTopic, "moveerr",
                          $theAttachment, $moveError );
         return;
       }
     } else {
-      if( ! $doAllowNonWikiWord && ! &TWiki::isWikiName( $newTopic ) ) {
+      if( ! $doAllowNonWikiWord && ! TWiki::isValidWikiWord( $newTopic ) ) {
         TWiki::UI::oops( $newWeb, $newTopic, "renamenotwikiword" );
         return;
       }
@@ -462,7 +491,7 @@
 
     my $problems;
     ( $lockFailure, $problems ) = 
-      &TWiki::Store::updateReferingPages( $oldWeb, $oldTopic, $wikiUserName, $newWeb, $newTopic, @refs );
+      &TWiki::Store::updateReferringPages( $oldWeb, $oldTopic, $wikiUserName, $newWeb, $newTopic, @refs );
   }
 
   my $new_url = "";
@@ -610,7 +639,7 @@
 #==========================================
 # Check that various webs and topics exist or don't exist as required
 sub _checkExist {
-  my( $oldWeb, $oldTopic, $newWeb, $newTopic, $theAttachment, $oldFileName, $newFileName ) = @_;
+  my( $oldWeb, $oldTopic, $newWeb, $newTopic, $theAttachment ) = @_;
 
   my $ret = 0;
   my $query = TWiki::getCgiQuery();
@@ -618,30 +647,34 @@
   $ret = 1 unless TWiki::UI::webExists( $oldWeb, $oldTopic );
   $ret = 1 unless TWiki::UI::webExists( $newWeb, $newTopic );
 
-  # Does old attachment exist?
-  if( ! -e $oldFileName) {
-    TWiki::UI::oops( $oldWeb, $oldTopic, "missing" );
-    $ret = 1;
+  if ( $theAttachment) {
+      # Does old attachment exist?
+      unless( TWiki::Store::attachmentExists( $oldWeb, $oldTopic,
+                                              $theAttachment )) {
+          TWiki::UI::oops( $oldWeb, $oldTopic, "moveerr", $theAttachment );
+          $ret = 1;
+      }
+      # does new attachment already exist?
+      if( TWiki::Store::attachmentExists( $newWeb, $newTopic,
+                                          $theAttachment )) {
+          TWiki::UI::oops( $newWeb, $newTopic, "moverr", $theAttachment );
+          $ret = 1;
+      }
+  } else {
+      # Check new topic doesn't exist
+      if( TWiki::Store::topicExists( $newWeb, $newTopic)) {
+          # Unless moving an attachment, new topic should not already exist
+          TWiki::UI::oops( $newWeb, $newTopic, "topicexists" );
+          $ret = 1;
+      }
   }
 
-  # Check new topic doesn't exist (opposite if we've moving an attachment)
-  if( defined( $newFileName ) && -e $newFileName && ! $theAttachment ) {
-    # Unless moving an attachment, new topic should not already exist
-    TWiki::UI::oops( $newWeb, $newTopic, "topicexists" );
-    $ret = 1;
-  }
-
-  if( defined( $newFileName ) && $theAttachment && ! -e $newFileName ) {
-    TWiki::UI::oops( $newWeb, $newTopic, "missing" );
-    $ret = 1;
-  }
-
   return $ret;
 }
 
 
 #============================
-#Return "" if can't get lock, otherwise "okay"
+# Return 1 if can't get lock, otherwise 0
 sub _getLocks {
   my( $oldWeb, $oldTopic, $newWeb, $newTopic, $theAttachment, $breakLock, $skin ) = @_;
   
@@ -652,7 +685,7 @@
     # Check for lock - at present the lock can't be broken
     ( $oldLockUser, $oldLockTime ) = &TWiki::Store::topicIsLockedBy( $oldWeb, $oldTopic );
     if( $oldLockUser ) {
-      $oldLockUser = &TWiki::userToWikiName( $oldLockUser );
+      $oldLockUser = &TWiki::User::userToWikiName( $oldLockUser );
       use integer;
       $oldLockTime = ( $oldLockTime / 60 ) + 1; # convert to minutes
     }
@@ -660,7 +693,7 @@
     if( $theAttachment ) {
       ( $newLockUser, $newLockTime ) = &TWiki::Store::topicIsLockedBy( $newWeb, $newTopic );
       if( $newLockUser ) {
-        $newLockUser = &TWiki::userToWikiName( $newLockUser );
+        $newLockUser = &TWiki::User::userToWikiName( $newLockUser );
         use integer;
         $newLockTime = ( $newLockTime / 60 ) + 1; # convert to minutes
         my $editLock = $TWiki::editLockTime / 60;
@@ -669,7 +702,7 @@
   }
 
   if( $oldLockUser || $newLockUser ) {
-    my $tmpl = &TWiki::Store::readTemplate( "oopslockedrename", $skin );
+    my $tmpl = TWiki::Templates::readTemplate( "oopslockedrename", $skin );
     my $editLock = $TWiki::editLockTime / 60;
     if( $oldLockUser ) {
       $tmpl =~ s/%OLD_LOCK%/Source topic $oldWeb.$oldTopic is locked by $oldLockUser, lock expires in $oldLockTime minutes.<br \/>/go;
@@ -687,17 +720,18 @@
     $tmpl = &TWiki::handleCommonTags( $tmpl, $oldTopic, $oldWeb );
     $tmpl = &TWiki::Render::getRenderedVersion( $tmpl, $oldWeb );
     $tmpl =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
-    TWiki::writeHeader( $query );
+    # SMELL: this is a redirect!
+    TWiki::writeHeader( $query, length( $tmpl ));
     print $tmpl;
-    return "";
+    return 0;
   } else {
-    &TWiki::Store::lockTopicNew( $oldWeb, $oldTopic );
+    TWiki::Store::lockTopic( $oldWeb, $oldTopic );
     if( $theAttachment ) {
-      &TWiki::Store::lockTopicNew( $newWeb, $newTopic );
+      TWiki::Store::lockTopic( $newWeb, $newTopic );
     }
   }
 
-  return "okay";
+  return 1;
 }
 
 #============================
@@ -714,16 +748,15 @@
   my $nonWikiWordFlag = "";
   $nonWikiWordFlag = 'checked="checked"' if( $doAllowNonWikiWord );
 
-  TWiki::writeHeader( $query );
   if( $theAttachment ) {
-    $tmpl = TWiki::Store::readTemplate( "moveattachment", $skin );
+    $tmpl = TWiki::Templates::readTemplate( "moveattachment", $skin );
     $tmpl =~ s/%FILENAME%/$theAttachment/go;
   } elsif( $confirm ) {
-    $tmpl = TWiki::Store::readTemplate( "renameconfirm", $skin );
+    $tmpl = TWiki::Templates::readTemplate( "renameconfirm", $skin );
   } elsif( $newWeb eq "Trash" ) {
-    $tmpl = TWiki::Store::readTemplate( "renamedelete", $skin );
+    $tmpl = TWiki::Templates::readTemplate( "renamedelete", $skin );
   } else {
-    $tmpl = &TWiki::Store::readTemplate( "rename", $skin );
+    $tmpl = TWiki::Templates::readTemplate( "rename", $skin );
   }
 
   $tmpl = _setVars( $tmpl, $oldTopic, $newWeb, $newTopic, $nonWikiWordFlag );
@@ -735,6 +768,8 @@
   $tmpl =~ s/%RESEARCH/%SEARCH/go; # Pre search result from being rendered
   $tmpl = &TWiki::handleCommonTags( $tmpl, $oldTopic, $oldWeb );   
   $tmpl =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
+
+  TWiki::writeHeader( $query, length( $tmpl ));
   print $tmpl;
 }
 
@@ -752,13 +787,14 @@
   my( $oldWeb, $oldTopic, $newWeb, $newTopic, $skin ) = @_;
   my $query = TWiki::getCgiQuery();
 
-  TWiki::writeHeader( $query );
-  my $tmpl = TWiki::Store::readTemplate( "renamerefs", $skin );
+  my $tmpl = TWiki::Templates::readTemplate( "renamerefs", $skin );
   $tmpl = _setVars( $tmpl, $oldTopic, $newWeb, $newTopic );
   $tmpl = TWiki::Render::getRenderedVersion( $tmpl );
   $tmpl =~ s/%RESEARCH/%SEARCH/go; # Pre search result from being rendered
   $tmpl = TWiki::handleCommonTags( $tmpl, $oldTopic, $oldWeb );
   $tmpl =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
+
+  TWiki::writeHeader( $query, length( $tmpl ));
   print $tmpl;
 }
 
Index: lib/TWiki/UI/Viewfile.pm
===================================================================
--- lib/TWiki/UI/Viewfile.pm	(revision 1767)
+++ lib/TWiki/UI/Viewfile.pm	(working copy)
@@ -66,7 +66,7 @@
   # Convert only if html file does not yet exist
   # for now, show the original document:
 
-  my $pubUrlPath = &TWiki::getPubUrlPath();
+  my $pubUrlPath = $TWiki::pubUrlPath;
   my $host = $TWiki::urlHost;
   TWiki::UI::redirect( "$host$pubUrlPath/$webName/$topic/$fileName" );
 }
Index: lib/TWiki/UI/RDiff.pm
===================================================================
--- lib/TWiki/UI/RDiff.pm	(revision 1767)
+++ lib/TWiki/UI/RDiff.pm	(working copy)
@@ -329,7 +329,7 @@
     my( $web, $rev, $topic, $short ) = @_;
 
     my( $date, $user ) = &TWiki::Store::getRevisionInfo( $web, $topic, "1.$rev");
-    $user = TWiki::Render::getRenderedVersion( TWiki::userToWikiName( $user ) );
+    $user = TWiki::Render::getRenderedVersion( TWiki::User::userToWikiName( $user ) );
 	
     if ( $short ) {
 	    $date = TWiki::formatTime( $date, "\$day \$month \$year" );
@@ -373,8 +373,7 @@
   my $diffType = $query->param('type');
   my $contextLines = $query->param('context');
   $contextLines = &TWiki::Prefs::getPreferencesValue( "DIFFCONTEXTLINES" ) unless ( $contextLines );
-  my $skin = $query->param( "skin" );
-  $skin = &TWiki::Prefs::getPreferencesValue( "SKIN" ) unless ( $skin );
+  my $skin = TWiki::getSkin();
   my $rev1 = $query->param( "rev1" );
   my $rev2 = $query->param( "rev2" );
 
@@ -396,7 +395,7 @@
   my $isMultipleDiff = 0;
   my $scriptUrlPath = $TWiki::scriptUrlPath;
 
-  $tmpl = &TWiki::Store::readTemplate( "rdiff", $skin );
+  $tmpl = TWiki::Templates::readTemplate( "rdiff", $skin );
   $tmpl =~ s/\%META{.*?}\%//go;  # remove %META{"parent"}%
 
   my( $before, $difftmpl, $after) = split( /%REPEAT%/, $tmpl);
@@ -429,7 +428,7 @@
   }
 
   # check access permission
-  my $wikiUserName = &TWiki::userToWikiName( $userName );
+  my $wikiUserName = &TWiki::User::userToWikiName( $userName );
   my $viewAccessOK = &TWiki::Access::checkAccessPermission( "view", $wikiUserName, "", $topic, $webName );
   if( $TWiki::readTopicPermissionFailed ) {
     # Can't read requested topic and/or included (or other accessed topics)
@@ -462,8 +461,7 @@
   $before = &TWiki::handleCommonTags( $before, $topic );
   $before = &TWiki::Render::getRenderedVersion( $before );
   $before =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
-  &TWiki::writeHeader( $query );
-  print $before;
+  my $page = $before;
 
   # do one or more diffs
   $difftmpl = &TWiki::handleCommonTags( $difftmpl, $topic );
@@ -490,7 +488,7 @@
       #            }
       $diff =~ s/%TEXT%/$text/go;
       $diff =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
-      print $diff;
+      $page .= $diff;
       $r1 = $r1 - 1;
       $r2 = $r2 - 1;
       if( $r2 < 1 ) { $r2 = 1; }
@@ -502,12 +500,12 @@
     $diff =~ s/%REVTITLE2%/$revTitle2/go;
     $diff =~ s/%TEXT%//go;
     $diff =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
-    print $diff;
+    $page .= $diff;
   }
   
   if( $TWiki::doLogTopicRdiff ) {
     # write log entry
-    &TWiki::Store::writeLog( "rdiff", "$webName.$topic", "r1.$rev1 r1.$rev2" );
+    TWiki::writeLog( "rdiff", "$webName.$topic", "r1.$rev1 r1.$rev2" );
   }
   
   # format "after" part
@@ -550,7 +548,10 @@
   $after = &TWiki::Render::getRenderedVersion( $after );
   $after =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
   
-  print $after;
+  $page .= $after;
+
+  TWiki::writeHeader( $query, length( $page ));
+  print $page;
 }
 
 1;
Index: lib/TWiki/UI/Statistics.pm
===================================================================
--- lib/TWiki/UI/Statistics.pm	(revision 1767)
+++ lib/TWiki/UI/Statistics.pm	(working copy)
@@ -50,9 +50,11 @@
 
     if( $query ) {
       # running from CGI
-      TWiki::writeHeader( $query );
-      print "<html>\n<head>\n<title>TWiki: Create Usage Statistics</title>\n";
-      print "</head>\n<body>\n";
+        my $mess =
+          "<html>\n<head>\n<title>TWiki: Create Usage Statistics</title>\n" .
+            "</head>\n<body>\n";
+        TWiki::writeHeader( $query, length( $mess ));
+        print $mess;
     }
 
     # Initial messages
@@ -368,7 +370,7 @@
     $dummy = "";  # to suppress warning
 
     if( $isFirstTime ) {
-        my $tmp = &TWiki::userToWikiName( $userName, 1 );
+        my $tmp = &TWiki::User::userToWikiName( $userName, 1 );
         $tmp .= " as shell script" unless( $query );
         _printMsg( "* Executed by $tmp", $query );
     }
